//----------------------------------------------------------------------
// Titel     : DSP Heimradio Display include file
//----------------------------------------------------------------------
// Dateiname : display.h
// Includes  : -
// Hinweis   : display.h den source Files hinzuf.
//----------------------------------------------------------------------
// Datum     : 24.04.2014 22:43:33
// Version   : 1.02
// Autor     : Andreas Nestler
// Changes   :
//		v1   : initial version; Display extracted control functions
//      v1.01: some small updates to avoid globals and extern
//      v1.02: new int to ascii routine to speed up
//             and to avoid old data fragments
//----------------------------------------------------------------------

#ifndef __DISPLAY_H__  /* Header wrapper to avoid multiple inclusion */
#define __DISPLAY_H__

/*
** constant definitions
*/
#define SSD1306_I2C_ADDRESS  0x78 // device address of SSD1306 see datasheet
// b7 b6 b5 b4 b3 b2 b1  b0
// 0  1  1  1  1  0  SA0 R/W
// 7bit address 0x3C once left shifted -> multiply by 2

/* display start logo graphics */ 
// 1 - show start logo on display
// 0 - No start logo
#define DISPLAY_START_LOGO 0


#define SSD1306_SETCONTRAST 0x81
#define SSD1306_DISPLAYALLON_RESUME 0xA4
#define SSD1306_DISPLAYALLON 0xA5
#define SSD1306_NORMALDISPLAY 0xA6
#define SSD1306_INVERTDISPLAY 0xA7
#define SSD1306_DISPLAYOFF 0xAE
#define SSD1306_DISPLAYON 0xAF

#define SSD1306_SETDISPLAYOFFSET 0xD3
#define SSD1306_SETCOMPINS 0xDA

#define SSD1306_SETVCOMDETECT 0xDB

#define SSD1306_SETDISPLAYCLOCKDIV 0xD5
#define SSD1306_SETPRECHARGE 0xD9

#define SSD1306_SETMULTIPLEX 0xA8

#define SSD1306_SETLOWCOLUMN 0x00
#define SSD1306_SETHIGHCOLUMN 0x10

#define SSD1306_SETSTARTLINE 0x40

#define SSD1306_MEMORYMODE 0x20

#define SSD1306_COMSCANINC 0xC0
#define SSD1306_COMSCANDEC 0xC8

#define SSD1306_SEGREMAP 0xA0

#define SSD1306_CHARGEPUMP 0x8D

#define SSD1306_EXTERNALVCC 0x1
#define SSD1306_SWITCHCAPVCC 0x2


/*
** function prototypes
*/ 
void print_a_char(unsigned char ascii);
void setup_OLED(void);
void ssd1306_command(char com);
void clear_display(void);
void SendChar(char data);
void setXY(unsigned char row,unsigned char col);
void sendStrXY(unsigned char row,unsigned char col,char *string);
void init_OLED(void);

/*
** globale Variablen - extern, da in DSP_heimradio1.c definiert
*/
//extern tRSQ rsq;							/* deklariert Variable des Typs tRSQ */



#endif


